// my_class.cpp
// This program demonstrates the development of a 
// class using functions as the building block.  

#include "my_essentials.hpp"

class water{

public: /* Public means the following  statements are directly accessible to all users of this class */ 
	string get_water(){/* This is a member function of this class and it works as an interface between its implementation and its users */
		return make_water();
	}

private: /* Private means the following statements are not directly accessible to users of this class. Private are specifically for data and implementations (definitions) of functions.*/
	 
	string hydrogen(){ 
		return "H";
	}
	string oxygen(){
		return "O";
	}
	string make_water(void){
		return (hydrogen()+"2"+oxygen());
	}
};


int main()
{
	water wt;	// wt is a variable of type 
			// "class water". 
	cout 	<< "\n Have some " << wt.get_water() 
		<< endl;
	// The "." is used to access 
	// a member of class, 
	// and its generalised syntax is 	
	// "object_variable_name.member_name".
 	// Here the member function get_water() is
	// accessed, but the other member function
	// make_water() cannot be accessed, 
	// because that is in private.   
	just_pause();
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
