// range-based-for.cpp 
// Note: It is implemented in VC++2012 and G++4.7.0, 
// but not in VC++2010.

#include "my_essentials.hpp"

int main()
{
	string my_str = "HELLO!";
	cout << "\nElements of my_str are: ";

	for(auto element : my_str)
		cout << element << ' ';
	
	/* 
	This is cleaner and shorter than the 	   
	traditional methods of using:
	
	(a) Subscript operator []: 

	for(auto i = 0; i !=  my_str.size(); ++i)
		cout << my_str[i] << ' ';

	(b) STL iterator [refer section 2.14]:

	for(auto it = my_str.begin(); 
			it !=  my_str.end(); ++it)
		cout << *it << ' ';
	*/

	vector<int> my_vec(5);// vector of 5 integers 
	
	// non-constant reference (&) must be 
	// used for assignment [refer to section 2.2]
	for(auto &element: my_vec)
	{
		static auto i = 1; // use of the
		// keyword 'static' at declaration 
		// prevents re-declaration 
		// at each loop cycle
		
		element = 2*i; // here, each element
		// is assigned to natural even numbers
		++i;
	}

	cout << "\nElements of my_vec are: ";

	for(auto element : my_vec)
		cout << element << ' ';

	just_pause();
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
