// properties_of_reference.cpp

#include "my_essentials.hpp"

class reference_property1{

	void pass_by_value(string color){
		color = "GREEN";
	}

	void pass_by_reference(string& color){ 
		color = "GREEN";
	}

	void pass_by_const_reference
		(const string& color){ 
		//color = "GREEN"; => error: 			
		//color is a constant, so it can 		
		//not change its value.
	}
public:
	void test();
};
	
void reference_property1::test()
{
	string color = "RED";
	cout << "\n Pass_by_value:"
		 << "\n\tinitial color:\t" 
		 << color;
	pass_by_value(color);
	cout << "\n\tfinal color:\t" 
		 << color;

	color = "RED";
	cout << "\n\n Pass_by_reference: "
		 << "\n\tinitial color:\t" 
		 << color;
	pass_by_reference(color);
	cout << "\n\tfinal color:\t" 
		 << color;

	color = "RED";
	cout << "\n\n Pass_by_const_reference: "
		 << "\n\tinitial color:\t" 
		 << color;
	pass_by_const_reference(color);
	cout << "\n\tfinal color:\t" 
		 << color;	
}

int main()
{
	reference_property1 rp1;
	rp1.test();
	cout << "\n--------------------\n";
	just_pause();
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
