// memory_scope.cpp
#include <iostream>
#include <string>

using namespace std; /* It belongs to Namespace scope that is a File scope in Static storage */

void myfunction(string some_description); /* The variable "some_words" in this function prototype is a Prototype scope, it is of no use in execution, but it is a message to the reader of the program, so the above function is the same as:
	void myfunction(string);	
*/

int main()
{
	myfunction("function scope A");
	cout << "\n\n\tpress enter a key to exit: ";
	char a;
	cin >> a;
}

string g_scope("global scope"); /* Global variable belongs to File scope and is stored in the Static storage */

class myclass
{
public:
	string c_scope;
	myclass(): c_scope("class scope"){}	
};

void myfunction(string f_scope1) /* f_scope1 belongs to Local scope, not a prototype scope, and is stored in the Automatic storage */
{ 
 static string f_scope2("function scope B"); /* it also belongs to Local scope and is stored in the Static storage */
 cout 	<< "\nScopes starting from the nearest, "
	<< "i.e., highest priority"
	<< " to the farthest, i.e.," 
	<< "lowest priority are:" 	
		<<"\n\n\n\t* ";
 cout << f_scope2; //Local scope
 cout << "\n\t* " << f_scope1; //Local scope
 static myclass *mc = new myclass; // Free storage
				// because it uses "new"
 cout << "\n\t* " << mc->c_scope;  //Class scope
 cout << "\n\t* " << g_scope; //Global scope
 cout << endl;
 delete mc; // Free storage
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
