// this_pointer.cpp
#include "my_essentials.hpp"
class myclass
{
public:
	myclass(){x =0;}
	//the default constructor assigns 0 to x.
	void myfunction();
	int x;
};
void myclass::myfunction()
{
int x = 0;

this->x = 100;
// using 'this' pointer, the data member of the 
// class is assigned to 100, without any ambiguity.

x = 10; 
//assigns 10 to the local x
	
cout <<"\nAt myclass::myfunction:"
<< "\nmyclass::myfunction x \t\t= "<<x
<<"\nmyclass::myfunction this->x \t= "<<(this->x)
<<"\nmyclass::myfunction (*this).x\t= "<<(*this).x
// Both are valid ways of using 'this' pointer 
// to call members of the class, because,
// both arrow '->' and dot '.' are 
// member selection operators.
<<"\nmyclass::myfunction this \t= "<< this<<endl;
//The value of 'this' pointer is the address of the class.

}

int main()
{
	myclass mc;
	cout 	<<"\nAt main() function:"
	<< "\n\tmyclass::x \t\t= "<<mc.x
	<<"\n\t&(myclass mc) \t\t= "<<&mc<<endl;

	cout	<<"\ncalling myclass::myfunction()";
	mc.myfunction();

	cout 	<<"\nAgain at main() function:"
	<< "\n\tmyclass::x \t\t= " << mc.x
	<<"\n\t&(myclass mc) \t\t= " << &mc << endl;
	just_pause();
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
