// cout_containers.cpp
// cout_using_iterators.cpp
#include "my_essentials.hpp"
#include <array>
#include <vector>
#include <unordered_set>
#include <forward_list>
#include <set>

int main()
{

	// Let us define, 

	// a fixed-size array
	array<int,6> arr = {1,3,5,1,2,4};
	cout_container("my array\t = ", arr);
	
	// a vector
	vector<int> vec(arr.begin(), arr.end());
	cout_container("my vector\t = ", vec);
	
	// a forward_list
	forward_list<int>
		f_lis(arr.begin(), arr.end());
	cout_container("my forward_list\t = ",f_lis);
	
	// an unordered_set
	unordered_set<int>
		u_set(arr.begin(), arr.end());
	cout_container("my unordered_set = ", u_set);
	
	// a set container
	set<int>se(arr.begin(), arr.end());
	cout_container("my set\t\t = ", se);

	just_pause();
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
