// function_object.cpp
#include "my_essentials.hpp"

//Functor:
class tens{
	double element;
public:
	tens(): element(1.0) {}
	
	double operator()()
	{
		return element *= 10;		
	}
};

int main()
{	
	// Using Functor:
	vector<double>vfunctor(5);
	
	generate(vfunctor.begin(), 
		vfunctor.end(), tens());
	
	// Using the Lambda Function of 
	// section 4.4:
	vector<double>vlambda(5);
	
	generate(vlambda.begin(), vlambda.end(), 
		[]()->double
		{
			static double element=1;
			return element*=10;
		} 	
	);
	
	// printing the results:
	cout	<< "\tFunctor" <<"\t\t"
			<< "Lambda" << endl;
	for(unsigned int i =0; 
			i !=  vfunctor.size(); ++i)
		cout 	<< '\t' << vfunctor[i] 
				<< "\t\t"<< vlambda[i] << endl;	
	just_pause();
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
