// lambda.cpp
#include "my_essentials.hpp"

int Lambda() 
{

//A full lambda function statement with no task is:
[]{};

// Let us code Hello World lambda functions 
// in two possible ways:
//Method 1:
auto  myfunction = []{
	cout <<"\n\t Hello World!"<<endl;
};
cout<<"\n statement: myfunction();"<<endl; 
myfunction();
   
//Method 2:
auto mystring = []{
	return("\n\t Hello All!\n");
};
cout<<"\n statement: cout<<mystring();"<<endl; 
cout<<mystring();

// The following statements are for exploring 
// the use of lambda brackets []
string 
first = "\n\t I can capture all available objects ", 
second = "\n\t within my square brackets ",
third= "\n\t'[lambda capture but optional]'\n";

auto mycapture = [first, second, third]{
	cout<<first+second+third;
};
cout<<"\n statement: mycapture();"<<endl; 
mycapture();

auto my_default_capture = [=]{
	myfunction();
	cout	<<first
		<<"\n\t by value using [=] "
		<<"\n\t or by reference using [&]"
		<<"\n\t these are called default capture"<<endl;
};
cout<<"\n statement: my_default_capture();"<<endl; 
my_default_capture();

/* 
Note: 
	[=, &mydata] means capture every available object by value 
	except for mydata, which has to be captured by reference. 
	Similarly, [&, =mydata] means capture every available object 
	by reference except for mydata, which has to be 
	captured by value. 
	If an object is in static storage (e.g., like declared  
	as static or declared as a global variable) then it can be 
	captured by default, provided it is within the scope of 
	the lambda statement. So, it is not allowed to be mentioned 
	in the lambda capture (please refer to Answer 4.4b, Method 2).
	Within a class a Lambda function can capture a member 
	of the class either by using [this] pointer or by using 
	default capture [=] or [&]. But it cannot capture 
	the member by mentioning the name of the member.
*/

just_pause();
return 0;
}

int main()
{
	Lambda();
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
