// lambda-bind.cpp

#include "my_essentials.hpp"

void coffee(string beans, int milk, short sugar);

function<void()> 
	plain_coffee_bind //Bind 
	= bind(coffee,"good", 0, 1);

function<void()> 
	plain_coffee_lambda //equivalent Lambda 
	= [](){coffee("good", 0, 1);};

using namespace std::placeholders;/* 
'std::placeholders' defines _1, _2, _3,..., _N 
 for representing the first, second, third, ..., Nth 
 parameter in the existing function argument and 
 that placement need not be in that ascending order, 
 but that placement order should match 
 the new function argument.  */

function
	<void(string, short, int)> 
	personal_coffee_bind //Bind
	= bind(coffee, _1, _3, _2);

function<void(string, short, int)> 
	personal_coffee_lambda //equivalent Lambda
	= [](string beans, short sugar, int milk){
		coffee(beans, milk, sugar);};

int main()
{
	cout << "\nPlain_coffee_bind() presents:"; 
	plain_coffee_bind();
	
	cout << "\nplain_coffee_lambda() presents:";
	plain_coffee_lambda();
	
	cout << "\n------------------------------\n"
	<< "\npersonal_coffee_bind(\"premium\",2,1)"
	<< " presents:";
	personal_coffee_bind("premium",2,1);
	
	cout 
	<<"\npersonal_coffee_lambda(\"premium\",2,1)"
	<< " presents:";
	personal_coffee_lambda("premium",2,1);
	cout << "\n------------------------------\n";
	
	just_pause();
}

void coffee(string beans, int milk, short sugar)
{
	cout << "\n* Your coffee("
			<< beans << " beans + " 
			<< milk << " milk + " 
			<< sugar << " sugar), Enjoy!\n";
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
