// recursive_function.cpp

#include "my_essentials.hpp"

// Normal recursive function for evaluating a
// factorial:
//	long long factorial(short n)
//		return(n == 1)?1: n*factorial(n-1);

int main()
{
// Recursive Lambda function:
function<long long (short)>factorial = [&](short n){
	return (n==1)? 1 : n*factorial (n-1); }; 
	/* 
	In the recursive lambda function, the keyword 
	"auto"	cannot work, where as the function<> can
 	be used. Here, "long long" and "short" are
	the return type and parameter type of the
	lambda function, respectively.
	*/
	while(1){
		cout << "\nEnter an integer and get its " 
		<< "factorial:\n\n";
		double m;
		cin >> m;
		if(m < 0)
		{
			cout << "\n\t invalid input: " 
				<< m << endl; 
			break; 
			/* a Negative Input breaks this
 					infinite loop  */
		}
		short n = static_cast<short>(m);
		cout << "\tFactorial(" << n << ")\t= "
			<< (n? factorial(n): 1) << endl;
	}
	just_pause();
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
