// new_algorithm.cpp

// copy algorithm example
#include "..\..\my_essentials.hpp"

void new_algo(size_t sz) 
{
  vector<int> data(sz);
  auto start = data.begin();
  auto stop = data.end();
  cout <<"\n (1) void iota(FwdIt b, FwdIt e, T v):";
  iota(start, stop, 1); 
	// itoa() makes the given uninitialized
	// vector into a vector of filled elements of 
	// increasing order i.e., (1 2 3...),
  	// wonderful, isn't?
  cout_container("\ndata", data);
  cout << "\n void reverse ( BidirIt b, BidirIt e):";
  reverse(start,stop);
  cout << "\nAfter a reverse:\n";
  cout_container("data", data);
 //----------------------------------------------

  cout << "\n (2) FwdIt is_sorted(FwdIt b, FwdIt e (, bool f(x,y)) ):";
  if( is_sorted(start, stop, greater<int>()) )
	cout << "\nThe data is sorted in "
	 	 << "decending order\n";
  else
	cout << "\nThe data is not in "
	 	 <<  "sorted order\n";
  if(data.size() > 3)
  {
	cout << "\n void random_shuffle(RandIt b, RandIt e, (RandomNumberGenerator) ):";
	random_shuffle(start+3, stop);
	cout << "\nAfter random_shuffle of last"
	 	 << " five elements:\n";
	cout_container("data", data);
  }
 //----------------------------------------------

  cout << "\n (3) FwdIt is_sorted_until(FwdIt b, FwdIt e (, bool f(x,y))):";
  auto sorted_end = is_sorted_until(start, stop, greater<int>());
  cout	<< "\nHere, first "
	<< distance(start,sorted_end) /* distance(InputIt b, InputIt e) is an algorithm that 
returns the number of elements between b and e. */ 
	<< " elements are in decending order\n";
 //----------------------------------------------
  
  cout << "\n (4) bool all_of(InputIt b, InputIt e, bool f(x)):";
  if(all_of(start,stop,[](int i){return i > 0;}) )
	cout << "\nAll elements are positive.\n";
  else
	cout << "\nAll are not positive.\n";
 //----------------------------------------------

  cout << "\n (5) bool any_of(InputIt b, InputIt e, bool f(x)):";
  if(any_of(start,stop,[](int i){return i%2;}) )
	cout <<"\nIt has atleast one odd integer.\n";
  else
	cout << "\nIt has no odd integer.\n";
 //----------------------------------------------

  cout << "\n (6) bool none_of(InputIt b, InputIt e, bool f(x)):";
  if(none_of(start,stop,[](int i){return i>10;}) )
	  cout	<< "\nIt has no integer which is\n"
	 	<< "greater than 10.\n";
  else
	  cout	<< "\nIts all elements are lesser\n" 
	 	<< "than 10.\n";
 //----------------------------------------------

  cout	<< "\n (7) InputIt find_if_not(InputIt b, InputIt e, bool f(x) ):";
  auto found_at = find_if_not(start,stop,
	  [](int x){return x > 2;});
  if(found_at != stop)
	cout	<< "\nvalue less than 2 is found,\n" 
	 	<< "i.e., " << *found_at << endl;
 //----------------------------------------------

  vector<int> data1;
  data1.reserve(data.size());
  cout	 << "\n (8) copy_if(InputIt b, InputIt e, OutputIt out, bool f(x)):";
  copy_if(start,stop, 
	  back_inserter(data1), [](int x){
					return x%2;} );
  cout	<< "\nThe selection of odd numbers "
	<< "from data and copy to:\n";
  cout_container("data1", data1);
 //----------------------------------------------

  vector<int> data2;
  data2.reserve(data.size());
  cout	<< "\n (9) copy_n(InputIt b, size_t n, OutputIt out):";
  copy_n(start, sz/2, back_inserter(data2));
  cout	<< "\nThe selection of first five elements"
	<< " from data and copy to:\n";
  cout_container("data2", data2);
 //----------------------------------------------

  vector<int> data3(data.size());
  cout	<< "\n OutputIt copy(InputIt b, InputIt e, OutputIt out):";
  copy(start, stop, data3.begin());
  cout	<< "\nThe contents of data is copied to\n";
  cout_container("data3", data3);
 //----------------------------------------------
    
  vector<int> data4(data.size());
  cout	<< "\n BidirIt copy_backward(BidirIt b, BidirIt e,  BidirIt out);:";
  copy_backward(start, stop, data4.end());
  cout	<< "\nThe contents of data is copied\n"
   	<< "backward to" << endl;
  cout_container("data4", data4);
 //----------------------------------------------
  
  vector<int> data5(data3.size());
  cout	<< "\n (10) OutputIt move(InputIt b, InputIt e, OutputIt out):";
  move(data3.begin(), data3.end(), 
	  data5.begin());
  cout	<< "\nThe contents of data3 is moved to\n";
  cout_container("data5", data5);
 //----------------------------------------------
    
  vector<int> data6(data4.size());
  cout	<< "\n (11) BidirIt move_backward(BidirIt b, BidirIt e,  BidirIt out);:";
  move_backward(data4.begin(), data4.end(), 
	  data6.end());
  cout	<< "\nThe contents of data is copied backward to\n";
  cout_container("data6", data6); 
 //----------------------------------------------

  cout	<< "\n void partial_sort(RandIt start, RandIt sort_end, RandIt stop, (bool f(x,y)) ):";
  auto middle = data.size()/2;
  partial_sort(start, start+middle, stop);
  cout << "\nafter partial sort:\n"; 
  cout_container("data", data);
  //---------------------------------------------

  cout	<< "\n FwdIt partition( FwdIt b, FwdIt e, (bool f(x)) ):";
  auto even = [](int x){return x%2 == 0;};
  auto p = partition(start,stop, even);
  cout	<< "\nAfter a partiotion for even\n" 
	<< "numbers:\n";
  cout_container("data", data);
  cout	<< " so, data is separated at "
	<< *p << endl;
 //----------------------------------------------
  
  cout	<< "\n (12) FwdIt partition_point( FwdIt b, FwdIt e, (bool f(x)) ):";
  auto q = partition_point(start,stop, even);
  if(p==q)
	cout << "\nYes, it returned the partition location of the given partitioned array\n";
 //----------------------------------------------

  cout	<< "\n (13) bool is_partitioned( InputIt b, InputIt e, bool f(x) ):";
  auto r = is_partitioned(start,stop, even);
  if(r)
	cout	<< "\nYes, the given container is partitioned\n";
 //----------------------------------------------
  
  cout	<< "\n (14) pair<OutputIt, OutputIt> partition_copy( InputIt b, InputIt e, OutputIt out1, OutputIt out2, bool f(x) ):\n";
  vector<int>satisfied_part, unsatisfied_part;
  satisfied_part.reserve(data.size());
  unsatisfied_part.reserve(data.size());
  auto a_pair = 
	  partition_copy(start, stop, 
	  back_inserter(satisfied_part), 
	  back_inserter(unsatisfied_part), even);
  cout_container("\nsatisfied_part", satisfied_part);
  cout_container("unsatisfied_part", unsatisfied_part);		
 //---------------------------------------------- 
  
  cout	<< "\n (15) pair<const T&, const T&> minmax (const T& a, const T& b (, bool f(x,y)) ):\n";
  int a(5), b(7);
  auto my_pair = minmax(a,b);
  cout	<< "\n Let, a is 5 and b is 7,\n" 
   	<<  "so minmax yields my_pair["
   	<< my_pair.first
   	<< ","
   	<< my_pair.second
   	<< "]\n"; 

  swap(a,b);
  auto my_pair2 = minmax(a,b);
  cout	<< "\n Let, a is 7 and b is 5,\n" 
   	<< "so minmax yields my_pair2["
   	<< my_pair2.first
   	<< " "
   	<< my_pair2.second
   	<< "]\n"
   	<< "Thus, it is my_pair[min,max]\n"; 
//---------------------------------------------- 
   
  cout	<< "\n (16) pair<FwdIt, FwdIt> minmax_element (FwdIt b, FwdIt e (, bool f(x,y)) ):\n";
  auto my_pair3 = minmax_element(start,stop);
  cout_container("In data", data); 
  cout	<< "\n my_pair3 is ["
   	<< *my_pair3.first
   	<< ","
   	<< *my_pair3.second
   	<< "]\n"; 
//---------------------------------------------- 
   
  /* Heap,  
	(a) is a data structure;
	(b) its first element has the highest value;
	(c) it is called binary tree;
	(d) it is useful in implementing 
		priority queues; and
	(e) its member functions are:
		(1) make_heap(b,e,(f));
		(2) push_heap(b,e,(f));
		(3) pop_heap(b,e,(f));
		(4) sort_heap(b,e,(f));
		(5) is_heap(b,e,(f)); and
		(6) is_heap_until(b,e,(f));
  */   
 
  cout << "\n (17) RandIt is_heap_until(RandIt b, RandIt e (, bool f(x,y)) ):";  
  auto heap_end = is_heap_until(start, stop);
  cout_container("\nThe data", data);
  if(heap_end != stop)
	cout	<< "is heaped up to " 
	 	<< *heap_end << endl;
  else
	cout	<< "is fully heaped.\n";
 //---------------------------------------------

  cout << "\n void make_heap(RandIt b, RandIt e    (, bool f(x,y)) ):";
  make_heap(start,stop);
  cout	<< "\n (18) bool is_heap(RandIt b, RandIt e (, bool f(x,y)) ):";
  auto flag = is_heap(start,stop);
  cout_container("\nThe data", data); 
  if(flag)
	cout	<< "is fully heaped.\n";
  else
	cout	<< "is not fully heaped.\n";
 //---------------------------------------------
}

int main()
{
	size_t sz(8);
	new_algo(sz);
	just_pause();
	return 0;
}
