// personalized_algorithm.cpp

#include "../../my_essentials.hpp"

struct person
{
    int acc_num;
	string name;
	int share;
	person(int ac, string na, int sh) 
		: acc_num(ac), name(na), share(sh) {} 
	   // this is a constructor from arguments
	   // and it will be explained in section 4.2 
};

class personalized_sort{
public:
	void ascend_acc(vector<person>&);
	void descend_acc(vector<person>&);
	void alphabetical(vector<person>&);
	void reverse_alphabetical (vector<person>&);
	void shares(vector<person>&);
private:
	void cout_people(vector<person> &);
};

int main()
{
	vector<person> people;

	people.reserve(5); // it reserves five units of 
	// memory space for adding data
	people.emplace_back(person(263, "John", 67));
	// If you use VC12/ g++ 4.7 then just use
	// people.emplace_back(263, "John", 67);
	// because emplace can do in-place construction
	people.emplace_back(person(7828, "Bill",87));
	people.emplace_back(person(6145, "Mark",54));
	people.emplace_back(person(3545, "Zhui",61)); 
	people.emplace_back(person(4497,"Jeny",106));

	personalized_sort pl;
	
	cout
	<< "Given the vector \"people\" is:\n\n(a) ";
	pl.alphabetical(people);
	cout << "..........................\n\n(b) ";
	pl.reverse_alphabetical(people);
	cout << "..........................\n\n(c) ";
	pl.ascend_acc(people);
	cout << "..........................\n\n(d) ";
	pl.descend_acc(people);
	cout <<"...........................\n\n(e) ";
	pl.shares(people);
	cout << "...........................";
	
	just_pause();
}


void personalized_sort::ascend_acc
(vector<person>&people)
{
	cout << "Sorted in ascending order:\n\n";
	sort(people.begin(), people.end(), 
	[](const person& a, const person& b)
	{
		return a.acc_num < b.acc_num;
	} );
	cout_people(people);
}

void personalized_sort::descend_acc
			(vector<person>&people)
{
	cout << "Sorted in desending order:\n\n";
	sort(people.begin(), people.end(), 
	[](const person& a, const person& b)
	{
		return a.acc_num > b.acc_num;
	} );    
	cout_people(people);
}

void personalized_sort::alphabetical
			(vector<person>&people)
{   
	cout << "Sorted in alphabetical order:\n\n";
	sort(people.begin(), people.end(),	
	[](const person& a, const person& b)
	{
		return a.name< b.name;
	} );    
	cout_people(people);
}

void personalized_sort::reverse_alphabetical
			(vector<person>&people)
{
	cout	<< "Sorted in reverse "
	 	<< "alphabetical order:\n\n";

	sort(people.begin(), people.end(), 
	[](const person& a, const person& b)
	{
		return a.name> b.name;
	} );
	cout_people(people);
}

void personalized_sort::shares
			(vector<person>&people)
{
	cout << "Sorted in descending share:\n\n";
	sort(people.begin(), people.end(),	
	[](const person& a, const person& b)
	{
		return a.share > b.share;
	} );    
	cout_people(people);
}

void personalized_sort::cout_people
			(vector<person> &people) 
{
	//for(auto pep: people){//the range-based-for
	// is not compatible with VC10, therefore: 
	for(auto pep = people.begin(); 
		pep != people.end(); ++pep) {
		cout << pep->acc_num << '\t'
		 	 << pep->name << '\t'
		 	 << pep->share << endl;
	}
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
