// encapsulation.cpp

#include "my_essentials.hpp"

class Base{
	void base_private(){
		cout<<"\taccessed: base private\n";
	}
protected:
	void base_protected(){
		cout<<"\taccessed: base protected\n";
	}
public:
	void base_public(){
		cout<<"\taccessed: base public\n";
	}
};

class Derived : public Base{
public:
	void derived_public(){
		cout<<"\taccessed: derived public and "
			<<"\n\tfrom here,\n";
		base_public();		
		base_protected();
		//base_private(); INACCESSIBLE 
	}
protected:
	void derived_protected(){
		cout<<"\taccessed: derived protected\n";	
	}
};

int main()
{
	Derived dr;
	cout<<"calling: \"dr.base_public();\"\n";
	dr.base_public();	
	//dr.base_protected(); INACCESSIBLE 
	//dr.base_private(); INACCESSIBLE 
	
	cout<<"\ncalling: \"dr.derived_public();\"\n";
	dr.derived_public();
	//dr.derived_protected(); INACCESSIBLE 

	just_pause();
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
