// investor_virtual_function.h
/*
Task: A financial advisor (agent) analyzes the market data 
and suggests a portfolio of investment to his/her customers. 
*/

// This header file carries a declaration of a 
// virtual function in a base class and its 
// definitions in two derived classes:

#ifndef INVESTOR_VIRTUAL_FUNCTION_H
#define INVESTOR_VIRTUAL_FUNCTION_H

class advisor{
public:
	virtual void make_portfolio(){};
	// it is same as:
	//
	// virtual void make_portfolio() = 0;
	// 
	// it is because, function is declared in a 	
	// base class and is characteristically 	
	// defined in its derived classes.
};

class investor1: public advisor {
public:
	void make_portfolio();	
};

class investor2: public advisor {
public:
	void make_portfolio();
};

#endif


/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
