// cout2T.cpp

#include "my_essentials.hpp"
#include <map>
#include <unordered_map>

int main()
{	
	// Let us define, 
	// a multimap
	multimap<string, double>mmp;
	
	// The g++4.7 can assign values to multimap 
	// in a single step as described in C++11
	// mmp = { {"Crude_oil", -0.2}, 
	// {"Gold", +0.1}, {"S&P", +0.1}, 
	// {"Gold", +0.5}};
	// However VC12 cannot support it yet, 
	// so we declare a pair<> followed 
	// by inserts:
	typedef pair<string, double> pp;// where, the 
	// operator typedef declares a variable 'pp' 
	// as an alias to the type 
	// 'pair<string, double>', where pair<T1, T2> 
	// is a class defined in <utility> to couple 
	// together a pair of values of 
	// type T1 and T2.
	mmp.insert(pp("Crude_oil", -0.2));
	mmp.insert(pp("Gold", +0.1));
	mmp.insert(pp("S&P", +0.1));
	mmp.insert(pp("Gold", +0.5));
	/* 
	Note: multimap and unordered_multimap do not 
	support the operator[], i.e., 
	mmp["Crude_oil"] = -0.2; is not allowed in 
	them, but it is allowed in map and 
	unordered_map.
	*/
	cout_container2T("my multimap\t = ", mmp);

	// an unordered_map
	unordered_map<string,double>
			u_mp(mmp.begin(), mmp.end());
	cout_container2T("my unordered_map = ",u_mp);
	
	just_pause();
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
