// algorithm_vs_mem_operation.cpp

#include "my_essentials.hpp"
#include <set>

void stl_algo_vs_oper(multiset<int>mse)
{
	int sz = mse.size();
	//............................

	auto op = ofstream("count_mem_oper.txt");
	// In case, your compiler cannot compile the
	// this line, then write it in two setps:
	// ofstream op;
	// op.open("count_mem_oper.txt"); 

	cout 
  << "\n Using operator (member function) count():";

	cout << "\n\n\t mem_oper_start.txt\n";

	auto of = ofstream("mem_oper_start.txt");
	of.close(); 	// Empty files are made to 
			// track the time.

	for(auto i = 0; i != sz; ++i)
	op << mse.count(i) << endl;
	
	of = ofstream("mem_oper_stop.txt");
	of.close();
	cout << "\n\t mem_oper_stop.txt\n"; 

	op.close();
//............................

	op = ofstream("count_stl_algo.txt");

	cout
	<< "\n Using STL algorithm count():\n";

	cout << "\n\t stl_algo_start.txt \n"; 	
	of.close();
	of = ofstream("stl_algo_start.txt");

	for(auto i = 0; i != sz; ++i)
	op	<< count(mse.begin(), mse.end(), i) 
	 	<< endl;

	of = ofstream("stl_algo_stop.txt");
	of.close();
	cout 	<< "\n\t stl_algo_stop.txt \n"; 

	op.close();
//..............................
}

int main()
{
	multiset<int> mse;
	int sz = 10000;
	for(auto i = 0; i != sz; ++i)
		mse.insert(rand()%sz);
		
	stl_algo_vs_oper(mse);
	just_pause();
}
