// clock_time.cpp
// It extracts the current clock time.
// This code compiles in VC10 and VC12, but not in 
// GCC, because it uses Visual Studio specific 
// objects.

#include "my_essentials.hpp"
#include <ctime>

string clock_time();

int main()
{
	cout << "\nTime now: "  
		 << clock_time()
		 << endl;
	just_pause();
}

string clock_time()
{
	char buf[26];
	
	errno_t time_error; 
	// In the next chapter we will discuss 
	// the error detection type 'errno'.
    	
	time_t result = time(0); 
	// 'time_t' is an arithmetic type for holding 
	// long time intervals and 'time(NULL)' 
	// provides the current calendar time. 
	
	time_error = ctime_s(buf, sizeof(buf), 
						&result); 
	// The secure time convertor 'ctime_s' reads 
	// the time value pointed by the '&result' 
	// and writes an equivalent readable time in 
	// the 'buf' 

	if(!time_error)
		return buf;
	else
		cout << "\nError: potentially invalid"
		     << " argument for ctime_s()?!;\n"
		     << "\tError code: " 
		     << time_error << endl;
	return("\"Warning: error_in_time\"");
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
