// chrono_lab.cpp
//
// It works only in VC12, not in VC10 and GCC.

#include "my_essentials_and_concurrency.hpp"

#include <chrono> // available in VC++12
#include <windows.h> //of Visual studio 

void chrono_lab(const long long);

int main()
{
	const long long music_duration = 20;//seconds
	chrono_lab(music_duration);
	just_pause();
}

// Generating music with random numbers.
void chrono_lab(const long long music_duration)
{
cout << "\nEnjoy your music!:\n\n\t";

array<char, 8> note 
	= {' ', 'c', 'd', 'e', 'f', 'g', 'a', 'b'};
array<double, 8> hertz 
	= {0, 261.63, 293.66, 329.63, 349.23, 392, 440, 493.88};
// Data extracted with thanks from http://www.phy.mtu.edu/~suits/notefreqs.html 

auto play_start = time_now();
auto play_limit 
	= play_start +  
		chrono::seconds (music_duration);
	
auto choice = 0, length = 0, value = 0;

// The uniform integer distribution:
 auto uniform_rand = [](){
	static mt19937 engine;
 	static uniform_int_distribution<int> 
				circle(0, 100);  
 	return circle(engine); 
 };

while( time_now()< play_limit)
{
  while(!(length = uniform_rand()%4));
  for(auto i = 0; i != length; ++i)
  {
	choice = rand()%8;
	value = rand()%2;
	if(choice) 
	{
		if(value)
			cout << note[choice] << ' ';
		else
			cout <<note[choice]<<'`'<< ' ';
	}
	else
	{
		if(value)
			cout << note[choice] <<' '<<' ';
		else
			cout <<note[choice] << ' ';
	}
	
	// Let us use 
	// "Beep(DWORD Frequency, DWORD Duration)",
	// which is an object of the WinApi header 
	// <windows.h> in Visual Studio. 
	// The type DWORD represents a 32-bit 
	// unsigned integer in Windows data types 
	// (Windows).

	 Beep(static_cast<DWORD>(hertz[choice]), 
	 static_cast<DWORD>(200.0*(1.0 + value))
	 );
 
	}
  	cout << "/ ";
  }

  auto play_stop = std::chrono::system_clock::now();
  auto time_played = duration(play_start,play_stop);

  cout << "\n\n\t duration of this music play = " 
	<< time_played <<" nanoseconds,\n\t i.e., "
	<< time_played/1e9 << " seconds."<< endl;
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
