// algorithm_failure.cpp

#include "my_essentials.hpp"

template<class T>
void not_found_indicator(vector<T>data,T value,T min,T max)
{
cout_container("\n Let us define a vector:\n ",
data);
	//.......................................
	
cout	<<"\nSample 1: \nFind out an "
		<<"element in the vector that has" 
		<<" value "<< value <<".\n";
	auto my_pointer = 
	find(data.begin(), data.end(), value);
	/*
	find() is a nonmodifying sequence algorithm 
	that identifies the presence of a given 
	value (my_search) in the range from begin() 
	to one before end(). It returns the 
	leftmost (earliest) iterator where that 
	value is present. If that value is not present 
	in any iterator then it will return 
	the last iterator end to indicate 
	that the expected value was not found.
	*/

	if(my_pointer == data.end())
		cout<<" Not found: "<<value<<endl;
	else
		cout<<" Found: "<<*my_pointer<<endl;
	//...........................................
	cout	<<"\nSample 2: \nFind out the first"
		<<" element in the vector that has a"
		<<" value in the range from "<< min
		<<" to "<< max <<".\n";
	my_pointer = find_if(data.begin(),data.end(),
			[min,max](T& x) {
			return (x>=min)&&(x<=max);});

	if(my_pointer == data.end())
		cout	<<" Not found anything from "
			<< min <<" to "<< max <<endl;
	else
		cout	<<" Found: "
			<< *my_pointer <<endl;
	//...........................................

	cout	<<"\nSample 3: \nHow many number of"
		<<" elements are in the vector that"
		<<" has the value in the range from "
		<< min <<" to "<< max <<"?\n";

	int count = count_if(data.begin(),data.end(), 
				[min,max](T& x){
				return (x>=min)&&(x<=max);});
		
/* 
The function count_if() returns an integer 
and not a iterator. Therefore, the return 
value zero is same as the not found indicator 
for this function.
*/

	cout << " count = "<< count<<endl;
}

int main()
{
	cout	<<"\nIllustration of STL sequence"
 			<<" failure indicator\n";
	
	{
	cout<<"Task1:\n";

	int arr[] 
	= {1111, 1134, 1176, 1124, 1145, 1136};
	int value = 1145, min = 2130, max = 2140;
	vector<int>data(arr, 
		arr+ sizeof(arr)/sizeof(int) );
	not_found_indicator<int> (data, value, 
					min, max);
	}

	{
	cout<<endl<<"Task2:\n";

	string arr[] 
	= {"Tom", "Adam", "Vicky", "Zhu", "Mandy",
		"Peter", "Ed", "Fade", "Henry",
		"Dave", "Bill", "George", "Jack"};
	string value = "Eva", 
			min = "Ibarra", max = "Zhu";
	vector<string>data(arr, 
		arr+ sizeof(arr)/sizeof(string) );
	not_found_indicator<string> (data, value, 
						min, max);
	}
/*
Note: The int arr[] in Task1 and the string arr[] 
in Task2 have the same identifier name. 
Although it appears to be an error, it is not one, 
because their scope is separated by 
the curly brackets '{' and '}'.
*/
	just_pause();
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
