// exception_in_STL.cpp

#include "my_essentials.hpp"
#include <exception>

template<class T>
class my_class{
public:
void out_container(const vector<T>& vec){
	cout<<"\nSize  of the given vector = "
		<<vec.size()
		<<"\nIts elements are:\n";
	for(unsigned int i =0; i<=vec.size(); ++i){
	/* Logic error: 
	The condition should be "<" not "<=" */
		cout<<"index ["<<i<<"]  ";
		cout<<vec.at(i)<<endl;
	/* where, at() is a member function of 
	the vector and it can throw an exception, 
	whereas its equivalent index  [], 
	cannot throw  an exception */	
		}
	}
};

int main()
try{
	my_class<double> cs;
	vector<double>vec(4);
	generate(vec.begin(), vec.end(), rand);/* 
	this is filling the vector vec with random 
	numbers.*/
	cs.out_container(vec);
	
	just_pause();
	return 0;
}

catch (exception& e) {
    cerr 	<< "exception caught: " 
			<< e.what() << endl;
	just_pause();
}

catch(...){
	cout	<<"\n Problem: there is"
			<<" an unknown exception!\n";
	just_pause();
	return 2;
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
