// binary_file.cpp

#include "my_essentials.hpp"
#include <iomanip>

void write_binary(string& filename)
{		
	sure_write(filename);
	fstream fo(filename, ios_base::out 
				| ios_base::binary); 
// where | is bitwise or, 
// which combines the modes.
	
	char message[] = "\n This file consists of a continuous list of integers\n";
	short message_size = sizeof(message);
	fo.write( 
	reinterpret_cast<char *>(&message_size),
				sizeof(message_size));
	fo.write( message, sizeof(message));

	short data_buffer;
	for(short i = 1; i <= 20; ++i)
	{
		data_buffer = i*i;
		fo.write( 
		reinterpret_cast<char *>
		(&data_buffer), sizeof(data_buffer));
	}
	
	fo.close();
	cout << "\nThe file "<< filename 
		<< " is successfully written.\n";
}
	
int read_binary(string filename)
{
	cout << "\nNow reading the file "
			<< filename << ":\n";
	fstream fi(filename, ios_base::in 
				| ios_base::binary); 
	if(!fi){
		cout 	<< "\n Error in opening the"
			<< " file: "<< filename << endl;
		return 1;
	}


	short message_size;
	fi.read(reinterpret_cast<char *>
	(&message_size), sizeof(message_size));
	char *message = new char[message_size];
	fi.read( message, message_size);
	cout << message;
	delete []message;

	short alignment =1;
	short data_buffer;
	while(fi.read( reinterpret_cast<char *>
	(&data_buffer), sizeof(data_buffer)))
	{
		cout << setw(6)<< data_buffer;
		if(alignment%4==0) cout << endl;
		++alignment;
	}
	cout << endl;
	fi.close();
	return 0;
}

int main()
{
	string filename("my_data1.bin");
	write_binary(filename);
	read_binary(filename);
	just_pause();
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
