// factory_function_interface_diamond.cpp

#include "my_essentials.hpp"

/*
To simplify the procedure for coding the factory function at each time let us generalize this factory function.
*/
// First, include the header file of given virtual function
#include "ans10_diamond_virtual_function.h"
// Second, add aliases Base and Derived1, Derived2, etc. 
// to the given virtual function's base and dirived classes, respectively.
// For aliases, we can use a keyword 'typedef'

// EDIT ALIASES 
typedef robots Base;
typedef dig Derived1;
typedef shine Derived2;
typedef send Derived3;
typedef sell Derived4;

//-------------------------------

class my_factory
{
public:
    virtual unique_ptr<Base>createBase() = 0;
};
 
//ADD THIS PRODUCTION CLASS FOR ADDITIONAL DIRIVED CLASSES:

class production1: public my_factory
{
public:
    unique_ptr<Base> createBase()
    {
        return unique_ptr<Base>(new Derived1());
    }
};
 
class production2: public my_factory {
public:
    unique_ptr<Base> createBase() {
        return unique_ptr<Base>(new Derived2());
    } 
};

class production3: public my_factory
{
public:
    unique_ptr<Base> createBase()
    {
        return unique_ptr<Base>(new Derived3());
    }
};
 
class production4: public my_factory {
public:
    unique_ptr<Base> createBase() {
        return unique_ptr<Base>(new Derived4());
    } 
};

//------------------------------------------------
 
class my_production {
public:
    my_production(unique_ptr<my_factory> factory)
    {
        unique_ptr<Base> my_dynamic(factory->createBase());
		my_dynamic->
		// PUT IDENTIFIER NAME OF THE VIRTUAL FUNCTION BELOW:
					diamond();
		//---------------------------------------
	}
};
 
unique_ptr<my_factory> choose_Derived() {
    auto flag = '1';
    cout << endl << "Enter product number(1 or 2 or 3 or 4): ";
    cin >> flag;
	switch(flag){
		//ADD CASES FOR ADDITIONAL DERIVED CLASSES:
	case '1':
		return unique_ptr<my_factory> (new production1());
	case '2':
		return unique_ptr<my_factory> (new production2());
	case '3':
		return unique_ptr<my_factory> (new production3());
	case '4':
		return unique_ptr<my_factory> (new production4());
	default:
		cout << "\n Sorry, unknown product number: "<< flag<< endl;
		cout << "\nSo providing product1:\n";
		return unique_ptr<my_factory> (new production1());
	}
}
 
int main()
{
	unique_ptr<int> x(new int);
    	unique_ptr<my_production> 
		my_new_production
		(new my_production(choose_Derived()));
	just_pause();
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
