// common_constructors.cpp

#include "ans11_common_constructors_and_operators.h"

void my_container_demo
	::constructors_for_all_containers()
{
	// Constructors:
	cout	<< "All containers support "
		<< "constructors\n"
		<< "\nList of frequently used "
		<< "constructors:\n\n";
	
	// Default Constructor:
	cout	<< "(a) Default Constructor:\n\n"
		<< "\t vector<investment>vec_a;\n"
		<< "\t constructs:";	
	vector<investment>vec_a;
	cout_container("\n\t vec_a", vec_a);	
	cout <<"...........................\n"<<endl;
	
	// Constructors from Argument:
	cout	<< "(b) Constructor From "
		<< " Argument:\n\n";

	cout 	<< "\t vector<investment>vec_b1(1);\n"
		<< "\t constructs:";	
	vector<investment>vec_b1(1);
	cout_container("\n\t vec_b1", vec_b1);
	cout << endl;
	
	investment inv;
	cout	<< "\n\t " 
		<< "vector<investment>vec_b2(2,inv);"
		<< "\n\t constructs:";	vector<investment>vec_b2(2,inv);
	cout_container("\n\t vec_b2", vec_b2);	
	cout <<"...........................\n"<<endl;

	investment_data inv_data;
	array<investment,3> my_fixed_size_array = { 
				inv_data.bank1, 
				inv_data.bond1, 
				inv_data.real_estate1
	};
	// Range Constructor:	
	cout	<< "(c) Range Constructor:\n\n"
		<< "\t vector<investment>\n\t "
		<< "vec_c(\n\t\t "			
		<< "my_fixed_size_array.begin(),\n"
		<< "\t\t my_fixed_size_array.end()\n"
		<< "\t )\n";
	vector<investment> vec_c( 
			my_fixed_size_array.begin(),
			my_fixed_size_array.end()
	);
	cout_container("\n\t vec_c", vec_c);	
	cout <<"...........................\n"<<endl;
	
	// Copy Constructor:
	cout	<< "(d) Copy Constructor:\n\n"
		<< "\t vector<investment> "
		<< "vec_e(vec_d);\n" 
		<< "\t constructs:";	
	vector<investment> vec_d(vec_c);
	cout_container("\n\t vec_d", vec_c);	
	cout <<"...........................\n"<<endl;
	
	// Copy Assignment:
	vec_d = vec_b2;
	cout	<< "(e) Copy Assignment operator:\n\n"
		<< "\t vec_d = vec_b2;\n"
		<< "\t it replaces contents of LHS\n"
		<< "\t with contents of RHS, thus:";
	cout_container("\n\t vec_d", vec_d);	
	cout <<"...........................\n"<<endl;

	// Range Assignment:	
	cout<< "(f) Range Assignment:\n\n"
		<< "\t vec_d.assign( "
		<< "vec_c.begin(), vec_c.end());\n"
		<< "\t assigns:";
	vec_d.assign(vec_c.begin(), vec_c.end());
	cout_container("\n\t vec_d", vec_d);	
	cout <<"...........................\n"<<endl;
}
//

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
