// investment.cpp

#include "ans11_common_constructors_and_operators.h"

// definition for class investment:

investment::investment()
	:security("security"), 
	profit_return(0), 
	asset_risk(0){
}
	
investment::investment
	(string n, double mu, double sigma)
	:	security(n), profit_return(mu), 
		asset_risk(sigma){
}

investment::investment
	(double mu, double sigma)
	:	profit_return(mu), asset_risk(sigma), 
		security("s") {
}

investment::investment
	(const investment& new_inv) 
	:	security(new_inv.security), 
		profit_return(new_inv.profit_return), 
		asset_risk(new_inv.asset_risk){
}

investment& investment::
	operator=(const investment& new_inv){
		if(this==&new_inv)
			return *this;
		security = new_inv.security;
		profit_return = new_inv.profit_return;
		asset_risk = new_inv.asset_risk;
		return *this;
}

ostream& operator<<
	(ostream& os,	const investment& mc){
		os	<< "\n\t " 
			<< mc.security 
			<< "(" << mc.profit_return 
			<< ","<<mc.asset_risk<<") ";
		return os;
}
//---------------------------------------

// definition for class investment:

investment_data::investment_data()
	:	bank1("bank-savings", 0.02, 0.0),
		bond1("gov-bonds", 0.05, 0.01),
		real_estate1("real-estate", 0.04,
						 0.02),
		share1("S&P", 0.08, 0.11),
		car("car", -0.1, 0.05),
		gold("gold", 0.03, 0.01){
}

//---------------------------------------------

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
