// operations_in_sequence_containers.cpp
#include "my_essentials.hpp"
class my_vector_demo{
public:
	void operators_for_all_sequential_containers();
};

int main()
{
	my_vector_demo vdemo;
	vdemo.operators_for_all_sequential_containers();
	just_pause();
}

void my_vector_demo::operators_for_all_sequential_containers()
{
	cout << "\nList of \"operators\" common to all sequential containers:\n";
	//let us generate a sample vector (1,2,3,4,5,6)
	vector<double>my_vec1(2), my_vec2(8);
	generate(my_vec1.begin(), my_vec1.end(),
		[]()->double{static double d=1; return d++;} );
	generate(my_vec2.begin(), my_vec2.end(), 
		[]()->int{return rand()%10;} );
	cout_container("\n  Let us define two vectors:\n\tmy_vec1", my_vec1);
	cout_container("\tmy_vec2", my_vec2);

	cout << "\n  Use of operators (1) assign() \n  - erases existing elements and writes new values:"<<endl;
	my_vec1.assign(my_vec2.begin()+1,my_vec2.end()-2);
	my_vec2.assign(4,2);
	cout_container("\n  After assigning part of second vector in first vector \n  and four 2s in second vector:\n\tmy_vec1", my_vec1);
	cout_container("\tmy_vec2", my_vec2);
	
	cout << "\n  Use of operators (2) front() and (3) back()\n  - provide references to first and last elements:"<<endl;
	cout << "\tmy_vec1.front() is : "<<my_vec1.front()<<endl;
	cout << "\tmy_vec1.back() is : "<<my_vec1.back()<<endl;
	
	cout << "\n  Use of operators (4) push_back() \n  - adds an element to the end :"<<endl;
	my_vec1.push_back(9876);
	cout_container("\tafter my_vec1.push_back(9876) the vector becomes\n\tmy_vec1",my_vec1);
	
	cout << "\n  Use of operators (5) pop_back() \n   - deletes the element at the end:"<<endl;
	my_vec1.pop_back();
	cout_container("\tafter my_vec1.pop_back() the vector becomes\n\tmy_vec1",my_vec1);

	cout << "\n  Use of operators (6) resize() \n   - either decrease size by erasing the required number of end elements" 
		<<" or increase size by adding elements of a provided value, however value zero is default:"<<endl;
	my_vec1.resize(8,5);
	cout_container("\tafter my_vec1.resize(8,5) the vector becomes\n\tmy_vec1",my_vec1);
	my_vec1.resize(4);
	cout_container("\tafter my_vec1.resize(4) the vector becomes\n\tmy_vec1",my_vec1);
	my_vec1.resize(6);
	cout_container("\tafter my_vec1.resize(6) the vector becomes\n\tmy_vec1",my_vec1);
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/

