// algorithm_vs_mem_operation.cpp
//
#include "my_essentials.hpp"
#include <unordered_set>

void stl_algo_vs_oper(unordered_multiset<int>u_mse)
{
	int sz = u_mse.size();
//............................
	auto op = ofstream("count_mem_oper.txt");

	cout 
<< "\n Using operator (member function) count():\n";

	cout << "\n\t mem_oper_start.txt\n";

	auto of = ofstream("mem_oper_start.txt");
	of.close(); 	// Empty files are made to 
			// track the time.

	for(auto i = 0; i != sz; ++i)
	op << u_mse.count(i) << endl;
	
	of = ofstream("mem_oper_stop.txt");
	of.close();
	cout << "\n\t mem_oper_stop.txt\n"; 

	op.close();
//............................
	op = ofstream("count_stl_algo.txt");

	cout 	
<< "\n Using STL Algorithm count():\n";

	cout << "\n\t stl_algo_start.txt \n"; 	
	of.close();
	of = ofstream("stl_algo_start.txt");

	for(auto i = 0; i != sz; ++i)
	op << count(u_mse.begin(), u_mse.end(), i) 
	   << endl;

	of = ofstream("stl_algo_stop.txt");
	of.close();
	cout << "\n\t stl_algo_stop.txt \n"; 

	op.close();
//..............................
}

int main()
{
	unordered_multiset<int> u_mse;
	int sz = 10000;
	for(auto i = 0; i != sz; ++i)
		u_mse.insert(rand()%sz);
		
	stl_algo_vs_oper(u_mse);
	just_pause();
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
