// dynamic_cast.cpp

# include "my_essentials.hpp"

class my_base_class{
public:
	virtual void my_function(){}
	virtual ~my_base_class() {}
};

class my_first_derived_class
	: public my_base_class{
};

class my_second_derived_class
	: public my_base_class{
};

void dynamic_reference(my_base_class &);

void dynamic_pointer(my_base_class*);

void dynamic_casting()
{
	cout << "Welcome to the dynamic_cast performance show";
			
	cout << "\n\n(1) Casting to a Reference:\n";
	my_base_class &mBc_ref 
			= my_second_derived_class();
	cout<<"\n Case: Base pointer is assigned to "
	 		<<"my_second_derived_class:\n";
	dynamic_reference(mBc_ref);
	
	cout <<"\n\n(2) Casting to a Pointer:\n";
	
	my_base_class *mBc_ptr 
			= new my_first_derived_class;
	cout<<"\n Case 1: Base pointer is assigned" 		
		<<" to my_first_derived_class:\n";
	dynamic_pointer(mBc_ptr);
	delete mBc_ptr;

	mBc_ptr = new my_second_derived_class;
	cout<<"\n Case 2: Base pointer is assigned" 
		<<" to my_second_derived_class:\n";
	dynamic_pointer(mBc_ptr);
	delete mBc_ptr;

	mBc_ptr = new my_base_class;
	cout<<"\n Case 3: Base pointer is assigned"
 				<<" to my_base_class:\n";
	dynamic_pointer(mBc_ptr);
	delete mBc_ptr;
}

int main()
{
	dynamic_casting();
	just_pause();
}
	

void dynamic_reference(my_base_class &mBc_ref)
	try
	{		
		my_first_derived_class &mDc_ref 
= dynamic_cast<my_first_derived_class&> (mBc_ref);
		cout << "Success! the base class "
			 << "reference 'mBc_ref' IS ASSIGNED" 
			 << "\n to the first derived class "
			 << "reference 'mDc_ref'\n";		
	}
	catch (const bad_cast& e)
	{
		cerr << " Exception: "<<e.what() 
		<< endl;
		cerr << " The base class reference 'mBc_ref' "
			 << "IS NOT ASSINGNED"	
			 << "\n to the first derived class "
			 << "reference 'mDc_ref'\n";	
	}

void dynamic_pointer(my_base_class *mBc_ptr)
{
	my_first_derived_class *mDc_ptr 
= dynamic_cast<my_first_derived_class*> (mBc_ptr); 	
	
	if(mDc_ptr != NULL)
	{
		cout<< " success! the base class pointer"
			<< "'mBc_ptr' IS POINTING" 
			<< "\n to the first derived class "
			<< "pointer 'mDc_ptr',\n";
	}
	else
	{
		my_second_derived_class  *mDc_ptr 
= dynamic_cast<my_second_derived_class*> (mBc_ptr);

			if(mDc_ptr != NULL)
			{
				cout << " success! the base class "
					 << "pointer 'mBc_ptr' IS POINTING" 
					 << "\n to the second derived class "
					 << "pointer 'mDc_ptr',\n";
			}
			else
			{
				cout << " Failure! the base class "
					 << "pointer 'mBc_ptr' IS POINTING" 
					 << "\n NEITHER to the first derived "
					 << "class NOR to the second derived class;\n";
			}
	}
	cout<<" it is so because, \n"
	<<" typeid(*mBc_ptr).name() shows"
	<<" that the pointer is\n"
	<<" dereferenced to \""
	<< typeid(*mBc_ptr).name()
	<<"\"\n";  

}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
