// const_cast.cpp

# include "my_essentials.hpp"

void print(char* st, double& data) 
{
	cout << st << data <<endl;
}

int main()
{
	const double my_savings = 981;
	double interest = 0.02;
	// my_savings *= (1+interest); // error     	
	// because my_savings is a constant, so use
	const_cast<double&>(my_savings) 
			*= (1+interest); // allowed
	// my_savings = 0; 
	// error because 	              	
	// my_savings again became constant
	print("\n My savings = ", 
		const_cast<double&> (my_savings) ); 
		// this casting is required, because
		// the second parameter of 				
		// function print() cannot accept 			
		// non constant object.
	just_pause();
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
